> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.propexo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.propexo.com/_mcp/server.

# Create Contract: Yardi REST

POST https://api.propexo.com/v1/contracts/yardi_rest/
Content-Type: application/json

Create Contract: Yardi REST| Interface | Method                     |
| --------- | -------------------------- |
| Job Cost  | /ItfJobCost/ImportContract |Due to PMS limitations, the ID of the created record cannot be retrieved. This will be found on the next data sync.

Reference: https://docs.propexo.com/api-reference/yardi-rest/construction-job-cost/create-contract-yardi-rest

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.propexo.com` (Production, default)
- `https://api.sandbox.propexo.com` (Sandbox)

## Request

### Body (application/json)

This endpoint expects a _v1_contracts_yardi_rest__post_input.

- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `vendor_id` (string, required) — The Propexo unique identifier for the vendor
- `start_date` (V1ContractsYardiRestPostInputStartDate, required) — The start date associated with the contract
- `contract_details` (list of V1ContractsYardiRestPostInputContractDetailsItems, required)
- `end_date` (V1ContractsYardiRestPostInputEndDate, optional) — The end date associated with the contract
- `notes` (string, optional) — Notes associated with the contract
- `expense_type` (string, optional) — The expense type of the contract. You'll have to request this data from your customer
- `retention_percent` (string, optional) — The retention percent of the contract. Must be a decimal number with only 2 places

## Response

### 200

Successful response

- `meta` (V1ContractsYardiRestPostOutputMeta, required)
- `result` (V1ContractsYardiRestPostOutputResult, required)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (ErrorResponseError, required)

## Types

### V1ContractsYardiRestPostInputStartDate

The start date associated with the contract

### V1ContractsYardiRestPostInputContractDetailsItems

- `construction_job_id` (string, required) — The Propexo unique identifier for the construction job
- `property_id` (string, required) — The Propexo unique identifier for the property
- `total_amount_in_cents` (double, required) — The amount of the contract detail, in cents
- `financial_account_id` (string, optional) — The Propexo unique identifier for the financial account
- `notes` (string, optional) — Notes associated with the contract detail
- `cost_code` (string, optional) — The cost code of the contract detail. You'll have to request this data from your customer
- `category_code` (string, optional) — The category code for the contract detail. You'll have to request this data from your customer
- `retention_percent` (string, optional) — The retention percent of the contract detail. Must be a decimal number with only 2 places

### V1ContractsYardiRestPostInputEndDate

The end date associated with the contract

### V1ContractsYardiRestPostOutputMeta

- `job_id` (string, required)

### V1ContractsYardiRestPostOutputResult

- `integration_id` (string, required) — The Propexo unique identifier for the integration
- `vendor_id` (string, required) — The Propexo unique identifier for the vendor
- `start_date` (V1ContractsYardiRestPostOutputResultStartDate, required, nullable)
- `end_date` (V1ContractsYardiRestPostOutputResultEndDate, required, nullable) — The end date associated with the contract
- `notes` (string, required, nullable) — Notes associated with the contract
- `expense_type` (string, required, nullable) — The expense type of the contract. You'll have to request this data from your customer
- `retention_percent` (string, required, nullable) — The retention percent of the contract. Must be a decimal number with only 2 places
- `contract_details` (list of V1ContractsYardiRestPostOutputResultContractDetailsItems, required)

### ErrorResponseError

- `code` (string, required)
- `message` (string, required)
- `details` (map from string to any, optional)

### V1ContractsYardiRestPostOutputResultStartDate

### V1ContractsYardiRestPostOutputResultEndDate

The end date associated with the contract

### V1ContractsYardiRestPostOutputResultContractDetailsItems

- `construction_job_id` (string, required) — The Propexo unique identifier for the construction job
- `property_id` (string, required) — The Propexo unique identifier for the property
- `total_amount_in_cents` (double, required) — The amount of the contract detail, in cents
- `financial_account_id` (string, optional) — The Propexo unique identifier for the financial account
- `notes` (string, optional) — Notes associated with the contract detail
- `cost_code` (string, optional) — The cost code of the contract detail. You'll have to request this data from your customer
- `category_code` (string, optional) — The category code for the contract detail. You'll have to request this data from your customer
- `retention_percent` (string, optional) — The retention percent of the contract detail. Must be a decimal number with only 2 places

## Examples

**Request**

```json
{
  "integration_id": "intg-9f8b7c6d5e4a3b2c",
  "vendor_id": "vend-1234567890abcdef",
  "start_date": "2024-01-15T09:30:00Z",
  "contract_details": [
    {
      "construction_job_id": "job-9876543210fedcba",
      "property_id": "prop-1122334455667788",
      "total_amount_in_cents": 1500000
    }
  ]
}
```

**Response**

```json
{
  "meta": {
    "job_id": "job-9876543210fedcba"
  },
  "result": {
    "integration_id": "intg-9f8b7c6d5e4a3b2c",
    "vendor_id": "vend-1234567890abcdef",
    "start_date": "2024-01-15T09:30:00Z",
    "end_date": "2025-01-15T09:30:00Z",
    "notes": "Annual maintenance contract for HVAC system",
    "expense_type": "Maintenance",
    "retention_percent": "5.00",
    "contract_details": [
      {
        "construction_job_id": "job-9876543210fedcba",
        "property_id": "prop-1122334455667788",
        "total_amount_in_cents": 1500000,
        "financial_account_id": "finacc-556677889900aabb",
        "notes": "Includes labor and materials",
        "cost_code": "CC-4500",
        "category_code": "CAT-300",
        "retention_percent": "5.00"
      }
    ]
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.propexo.com/v1/contracts/yardi_rest/"

payload = {
    "integration_id": "intg-9f8b7c6d5e4a3b2c",
    "vendor_id": "vend-1234567890abcdef",
    "start_date": "2024-01-15T09:30:00Z",
    "contract_details": [
        {
            "construction_job_id": "job-9876543210fedcba",
            "property_id": "prop-1122334455667788",
            "total_amount_in_cents": 1500000
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.propexo.com/v1/contracts/yardi_rest/';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"integration_id":"intg-9f8b7c6d5e4a3b2c","vendor_id":"vend-1234567890abcdef","start_date":"2024-01-15T09:30:00Z","contract_details":[{"construction_job_id":"job-9876543210fedcba","property_id":"prop-1122334455667788","total_amount_in_cents":1500000}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.propexo.com/v1/contracts/yardi_rest/"

	payload := strings.NewReader("{\n  \"integration_id\": \"intg-9f8b7c6d5e4a3b2c\",\n  \"vendor_id\": \"vend-1234567890abcdef\",\n  \"start_date\": \"2024-01-15T09:30:00Z\",\n  \"contract_details\": [\n    {\n      \"construction_job_id\": \"job-9876543210fedcba\",\n      \"property_id\": \"prop-1122334455667788\",\n      \"total_amount_in_cents\": 1500000\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.propexo.com/v1/contracts/yardi_rest/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"integration_id\": \"intg-9f8b7c6d5e4a3b2c\",\n  \"vendor_id\": \"vend-1234567890abcdef\",\n  \"start_date\": \"2024-01-15T09:30:00Z\",\n  \"contract_details\": [\n    {\n      \"construction_job_id\": \"job-9876543210fedcba\",\n      \"property_id\": \"prop-1122334455667788\",\n      \"total_amount_in_cents\": 1500000\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.propexo.com/v1/contracts/yardi_rest/")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"integration_id\": \"intg-9f8b7c6d5e4a3b2c\",\n  \"vendor_id\": \"vend-1234567890abcdef\",\n  \"start_date\": \"2024-01-15T09:30:00Z\",\n  \"contract_details\": [\n    {\n      \"construction_job_id\": \"job-9876543210fedcba\",\n      \"property_id\": \"prop-1122334455667788\",\n      \"total_amount_in_cents\": 1500000\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.propexo.com/v1/contracts/yardi_rest/', [
  'body' => '{
  "integration_id": "intg-9f8b7c6d5e4a3b2c",
  "vendor_id": "vend-1234567890abcdef",
  "start_date": "2024-01-15T09:30:00Z",
  "contract_details": [
    {
      "construction_job_id": "job-9876543210fedcba",
      "property_id": "prop-1122334455667788",
      "total_amount_in_cents": 1500000
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.propexo.com/v1/contracts/yardi_rest/");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"integration_id\": \"intg-9f8b7c6d5e4a3b2c\",\n  \"vendor_id\": \"vend-1234567890abcdef\",\n  \"start_date\": \"2024-01-15T09:30:00Z\",\n  \"contract_details\": [\n    {\n      \"construction_job_id\": \"job-9876543210fedcba\",\n      \"property_id\": \"prop-1122334455667788\",\n      \"total_amount_in_cents\": 1500000\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "integration_id": "intg-9f8b7c6d5e4a3b2c",
  "vendor_id": "vend-1234567890abcdef",
  "start_date": "2024-01-15T09:30:00Z",
  "contract_details": [
    [
      "construction_job_id": "job-9876543210fedcba",
      "property_id": "prop-1122334455667788",
      "total_amount_in_cents": 1500000
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.propexo.com/v1/contracts/yardi_rest/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```